Index: code/branches/buildsystem3/bin/CMakeLists.txt
===================================================================
--- code/branches/buildsystem3/bin/CMakeLists.txt	(revision 2705)
+++ code/branches/buildsystem3/bin/CMakeLists.txt	(revision 2709)
@@ -21,17 +21,13 @@
  #    Reto Grieder
  #  Description:
- #    Creates a run-script in the root directory of the build tree.
+ #    Creates run scripts in the root directory of the build tree and
+ #    the runtime output directory.
  #
 
-############ Configure Dev Build ##############
-
-
-################ Run Scripts ##################
-
-# Create a run script for Windows to manually add the DLL path when executing
+# Create run scripts for Windows to manually add the DLL path when executing
 IF(WIN32)
-  SET(RUN_SCRIPT run.bat)
+  SET(RUN_SCRIPTS run.bat client1.bat client2.bat server.bat)
 ELSEIF(UNIX)
-  SET(RUN_SCRIPT run)
+  SET(RUN_SCRIPTS run client1 client1 server)
 ENDIF()
 
@@ -51,9 +47,11 @@
   STRING(REPLACE "/" "\\" CURRENT_RUNTIME_DIR_WINDOWS ${CURRENT_RUNTIME_DIR})
 
-  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${RUN_SCRIPT}.in ${CURRENT_RUNTIME_DIR}/${RUN_SCRIPT} @ONLY)
-  IF(_subdir STREQUAL _default_subdir)
-    # Convenience script to be used when sitting in the binary directory. Defaults to Debug for msvc.
-    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${RUN_SCRIPT}.in ${CMAKE_BINARY_DIR}/${RUN_SCRIPT} @ONLY)
-  ENDIF()
+  FOREACH(_script ${RUN_SCRIPTS})
+    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${_script}.in ${CURRENT_RUNTIME_DIR}/${_script} @ONLY)
+    IF(_subdir STREQUAL _default_subdir)
+      # Convenience script to be used when sitting in the binary directory. Defaults to Debug for msvc.
+      CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${_script}.in ${CMAKE_BINARY_DIR}/${_script} @ONLY)
+    ENDIF()
+  ENDFOREACH(_script)
 
   # In order to evaluate at run time whether it is a dev build in the build tree,
Index: code/branches/buildsystem3/bin/client1.bat.in
===================================================================
--- code/branches/buildsystem3/bin/client1.bat.in	(revision 2709)
+++ code/branches/buildsystem3/bin/client1.bat.in	(revision 2709)
@@ -0,0 +1,6 @@
+title @PROJECT_NAME@
+path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
+@WINDOWS_DRIVE_CHANGE@
+cd @CURRENT_RUNTIME_DIR_WINDOWS@
+@ORXONOX_EXECUTABLE_NAME@ --state client --directory client1
+pause
Index: code/branches/buildsystem3/bin/client1.in
===================================================================
--- code/branches/buildsystem3/bin/client1.in	(revision 2709)
+++ code/branches/buildsystem3/bin/client1.in	(revision 2709)
@@ -0,0 +1,4 @@
+#!/bin/sh
+# convenience script for starting orxonox on Linux
+
+cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state client --directory client1 $@
Index: code/branches/buildsystem3/bin/client2.bat.in
===================================================================
--- code/branches/buildsystem3/bin/client2.bat.in	(revision 2709)
+++ code/branches/buildsystem3/bin/client2.bat.in	(revision 2709)
@@ -0,0 +1,6 @@
+title @PROJECT_NAME@
+path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
+@WINDOWS_DRIVE_CHANGE@
+cd @CURRENT_RUNTIME_DIR_WINDOWS@
+@ORXONOX_EXECUTABLE_NAME@ --state client --directory client2
+pause
Index: code/branches/buildsystem3/bin/client2.in
===================================================================
--- code/branches/buildsystem3/bin/client2.in	(revision 2709)
+++ code/branches/buildsystem3/bin/client2.in	(revision 2709)
@@ -0,0 +1,4 @@
+#!/bin/sh
+# convenience script for starting orxonox on Linux
+
+cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state client --directory client2 $@
Index: code/branches/buildsystem3/bin/server.bat.in
===================================================================
--- code/branches/buildsystem3/bin/server.bat.in	(revision 2709)
+++ code/branches/buildsystem3/bin/server.bat.in	(revision 2709)
@@ -0,0 +1,6 @@
+title @PROJECT_NAME@
+path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
+@WINDOWS_DRIVE_CHANGE@
+cd @CURRENT_RUNTIME_DIR_WINDOWS@
+@ORXONOX_EXECUTABLE_NAME@ --state server --directory server
+pause
Index: code/branches/buildsystem3/bin/server.in
===================================================================
--- code/branches/buildsystem3/bin/server.in	(revision 2709)
+++ code/branches/buildsystem3/bin/server.in	(revision 2709)
@@ -0,0 +1,4 @@
+#!/bin/sh
+# convenience script for starting orxonox on Linux
+
+cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state server --directory server $@