Index: code/trunk/bin/CMakeLists.txt
===================================================================
--- code/trunk/bin/CMakeLists.txt	(revision 2723)
+++ code/trunk/bin/CMakeLists.txt	(revision 2729)
@@ -29,5 +29,5 @@
   SET(RUN_SCRIPTS run.bat client1.bat client2.bat server.bat)
 ELSEIF(UNIX)
-  SET(RUN_SCRIPTS run client1 client2 server)
+  SET(RUN_SCRIPTS run client1 client2 server dedicated)
 ENDIF()
 
Index: code/trunk/bin/client1.bat.in
===================================================================
--- code/trunk/bin/client1.bat.in	(revision 2723)
+++ code/trunk/bin/client1.bat.in	(revision 2729)
@@ -1,6 +1,4 @@
 title @PROJECT_NAME@
 path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
-@WINDOWS_DRIVE_CHANGE@
-cd @CURRENT_RUNTIME_DIR_WINDOWS@
-@ORXONOX_EXECUTABLE_NAME@ --state client --directory client1
+@CURRENT_RUNTIME_DIR_WINDOWS@\@ORXONOX_EXECUTABLE_NAME@ --state client --directory client1
 pause
Index: code/trunk/bin/client1.in
===================================================================
--- code/trunk/bin/client1.in	(revision 2723)
+++ code/trunk/bin/client1.in	(revision 2729)
@@ -2,3 +2,3 @@
 # convenience script for starting orxonox on Linux
 
-cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state client --directory client1 $@
+exec .@CURRENT_RUNTIME_DIR@/@ORXONOX_EXECUTABLE_NAME@ --state client --directory client1 $@
Index: code/trunk/bin/client2.bat.in
===================================================================
--- code/trunk/bin/client2.bat.in	(revision 2723)
+++ code/trunk/bin/client2.bat.in	(revision 2729)
@@ -1,6 +1,4 @@
 title @PROJECT_NAME@
 path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
-@WINDOWS_DRIVE_CHANGE@
-cd @CURRENT_RUNTIME_DIR_WINDOWS@
-@ORXONOX_EXECUTABLE_NAME@ --state client --directory client2
+@CURRENT_RUNTIME_DIR_WINDOWS@\@ORXONOX_EXECUTABLE_NAME@ --state client --directory client2
 pause
Index: code/trunk/bin/client2.in
===================================================================
--- code/trunk/bin/client2.in	(revision 2723)
+++ code/trunk/bin/client2.in	(revision 2729)
@@ -2,3 +2,3 @@
 # convenience script for starting orxonox on Linux
 
-cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state client --directory client2 $@
+exec .@CURRENT_RUNTIME_DIR@/@ORXONOX_EXECUTABLE_NAME@ --state client --directory client2 $@
Index: code/trunk/bin/dedicated.bat.in
===================================================================
--- code/trunk/bin/dedicated.bat.in	(revision 2729)
+++ code/trunk/bin/dedicated.bat.in	(revision 2729)
@@ -0,0 +1,4 @@
+title @PROJECT_NAME@
+path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
+@CURRENT_RUNTIME_DIR_WINDOWS@\@ORXONOX_EXECUTABLE_NAME@ --state dedicated --directory dedicated
+pause
Index: code/trunk/bin/dedicated.in
===================================================================
--- code/trunk/bin/dedicated.in	(revision 2729)
+++ code/trunk/bin/dedicated.in	(revision 2729)
@@ -0,0 +1,4 @@
+#!/bin/sh
+# convenience script for starting orxonox on Linux
+
+cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state dedicated --directory dedicated $@
Index: code/trunk/bin/run.bat.in
===================================================================
--- code/trunk/bin/run.bat.in	(revision 2723)
+++ code/trunk/bin/run.bat.in	(revision 2729)
@@ -1,6 +1,4 @@
 title @PROJECT_NAME@
 path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
-@WINDOWS_DRIVE_CHANGE@
-cd @CURRENT_RUNTIME_DIR_WINDOWS@
-@ORXONOX_EXECUTABLE_NAME@
+@CURRENT_RUNTIME_DIR_WINDOWS@\@ORXONOX_EXECUTABLE_NAME@
 pause
Index: code/trunk/bin/run.in
===================================================================
--- code/trunk/bin/run.in	(revision 2723)
+++ code/trunk/bin/run.in	(revision 2729)
@@ -2,3 +2,3 @@
 # convenience script for starting orxonox on Linux
 
-cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ $@
+exec .@CURRENT_RUNTIME_DIR@/@ORXONOX_EXECUTABLE_NAME@ $@
Index: code/trunk/bin/server.bat.in
===================================================================
--- code/trunk/bin/server.bat.in	(revision 2723)
+++ code/trunk/bin/server.bat.in	(revision 2729)
@@ -1,6 +1,4 @@
 title @PROJECT_NAME@
 path @ORXONOX_RUNTIME_LIBRARY_DIRECTORY_WINDOWS@;%path%
-@WINDOWS_DRIVE_CHANGE@
-cd @CURRENT_RUNTIME_DIR_WINDOWS@
-@ORXONOX_EXECUTABLE_NAME@ --state server --directory server
+@CURRENT_RUNTIME_DIR_WINDOWS@\@ORXONOX_EXECUTABLE_NAME@ --state server --directory server
 pause
Index: code/trunk/bin/server.in
===================================================================
--- code/trunk/bin/server.in	(revision 2723)
+++ code/trunk/bin/server.in	(revision 2729)
@@ -2,3 +2,3 @@
 # convenience script for starting orxonox on Linux
 
-cd @CURRENT_RUNTIME_DIR@ && exec ./@ORXONOX_EXECUTABLE_NAME@ --state server --directory server $@
+exec .@CURRENT_RUNTIME_DIR@/@ORXONOX_EXECUTABLE_NAME@ --state server --directory server $@